// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Evaluator.h,v 0.9 1997-12-27 07:10:58+09 harada Exp $
//
#ifndef EVALUATOR_H_INCLUDED
#define EVALUATOR_H_INCLUDED
#include "Result.h"

class Evaluator {
public:
    Evaluator() { }
    virtual ~Evaluator() { }
/*
    virtual int and(Result *dst, int dstLen,
*/
    virtual int And(Result *dst, int dstLen,
                    const Result *src, int srcLen) const;
/*
    virtual int not(Result *dst, int dstLen,
*/
    virtual int Not(Result *dst, int dstLen,
                    const Result *src, int srcLen) const;
/*
    virtual int or(Result *dst, const Result *src1, int srcLen1,
*/
    virtual int Or(Result *dst, const Result *src1, int srcLen1,
                   const Result *src2, int srcLen2) const;
    virtual int rank(Result *result, int resultLen) const;
};

#endif
