// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: HashKey.h,v 0.9 1997-12-27 07:15:40+09 harada Exp $
//
#ifndef HASHKEY_H_INCLUDED
#define HASHKEY_H_INCLUDED

class HashKey {
public:
    int kid; // serial id number in creation order
    HashKey() : kid(0) {};
    virtual ~HashKey(){};
    virtual operator const char *() const = 0;
    virtual const char *toString() const = 0;
    virtual HashKey *clone() const = 0; // deep copy
    virtual unsigned int hashCode() const = 0;
    virtual int operator ==(const HashKey &that) const = 0;
    friend ostream& operator<<(ostream &stream, HashKey &w);
};

#endif
