// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
//  inverted index (i.e. document reference file)
//  $Id: IndexFile.h,v 0.9 1997-12-27 07:17:35+09 harada Exp $
//
#ifndef INDEXFILE_H_INCLUDED
#define INDEXFILE_H_INCLUDED

#include "SX.h"

class IndexFile {
public:
    IndexFile(const char *name, const char *mode);
    pos_t *fetch(wordid_t wid, int &listLen, ShiftMask *mask=NULL);
    int store(const pos_t *list, int listLen, wordid_t &wid);
    virtual ~IndexFile();
    int geterror(){ return error; }
protected:
    FILE *idxf;
    int error;
};

#endif
