// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: settemplate.cc,v 0.9 1997-12-27 07:51:41+09 harada Exp $
//
#include "SX.h"
#include "settemplate.h"

// There is no definition in this file -- just for debugging.

#ifdef SETTEMPLATE_DEBUG
// % /usr/bin/c++ -DSETTEMPLATE_DEBUG -Wall -O -g settemplate.cc

int main(){
    int i, n;
    pos_t x[] = { 1,2,4,8,16,32,64,128 };
    pos_t y[] = { 1,4,9,16,25,36,49,64,81 };
    pos_t z[100];

    n = multiplyList(z,
                     x, (int)(sizeof(x)/sizeof(x[0])),
                     y, (int)(sizeof(y)/sizeof(y[0])), 17);

    cout << "n = " << n << endl;
    for(i = 0; i < n; i++){
        cout << z[i] << endl;
    }

    n = mergeList(z,
                  x, (int)(sizeof(x)/sizeof(x[0])),
                  y, (int)(sizeof(y)/sizeof(y[0])));

    cout << "n = " << n << endl;
    for(i = 0; i < n; i++){
        cout << z[i] << endl;
    }

    n = subtractList(z,
                     x, (int)(sizeof(x)/sizeof(x[0])),
                     y, (int)(sizeof(y)/sizeof(y[0])));


    cout << "n = " << n << endl;
    for(i = 0; i < n; i++){
        cout << z[i] << endl;
    }
    
    return 0;
}

#endif
