// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: typedef.h,v 0.9 1997-12-27 07:52:50+09 harada Exp $
//
#ifndef TYPEDEF_H_INCLUDED
#define TYPEDEF_H_INCLUDED

// CODEINT ... integer to be coded by Coder
#include <sys/types.h>
#ifdef _MSC_VER /*----------------- Win32 */
#define CODEINT __int64
#define CPPINLINE static
#define CINLINE
#include <winsock2.h>
#include <io.h>
#include <direct.h>
#include <malloc.h>
#define PATH_MAX	255
#define LINE_MAX	2048
#define setBinaryIO()	{ _fmode = O_BINARY; }
int getopt(int ac, char **av, const char *spec);
#define mkdir(path,mode)	_mkdir(path)
int ftruncate(int fd, off_t length);
int gettimeofday(struct timeval *tp, struct timezone *tzp);
void *mmap(void *ad, size_t le, int pr, int fl, int fd, off_t of);
int munmap(void *ad, size_t le);
#define PROT_READ 0
#define MAP_SHARED 0
typedef void *caddr_t;

#else /*--------------------------- Unix */
#define CODEINT long long int
#define CPPINLINE inline
#define CINLINE inline
#include <strings.h>
#include <unistd.h>
#include <sys/param.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#define setBinaryIO()
#endif /*-------------------------- */

#include <sys/stat.h>
#include <assert.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <fcntl.h>
#include <limits.h>

// νи֤ɽ
// ŤоݤȤʤ벾ŪʥեǤΥեåȤ
typedef unsigned CODEINT pos_t;

/*
typedef unsigned int wordid_t;
*/
typedef off_t wordid_t;

// RecordBlock쥳ɤֹ
typedef unsigned short int recno_t;

// IndexFile֥å(RecordBlock)ֹ
typedef unsigned short int blockno_t;

// URLĤˤĤƤIDֹ
// ʬ󥸥ΤȤͤ64bit餤äƤ⤤
typedef unsigned int urlid_t;

// ֥åΥեåȤʤɤɽ16bitǤsize_t
typedef unsigned short int short_size_t;

// to be used to passed as func. arg. then put by "%X"
typedef unsigned int ArgInt;
// to be used to calculate size
typedef unsigned long int PtrInt;
#endif
