// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: HeapBag.cc,v 0.9 1997-12-27 07:16:03+09 harada Exp $
// just for debugging ..
//
#include "SX.h"
#include "HeapBag.h"
#include "Word.h"

int
main(){
    int size = 32;
    HeapBag<Word> h(size);
    Word words[size];

    char key[256];
    for(int i = 0; i < size && !cin.fail(); i++){
        cin >> key;
        words[i] = key;
    }

    h.printDebug();
    for(int i = 0; i < size; i++){
        cout << "insert: " << words[i] << endl;
        h.insert(&words[i]);
    }
    h.printDebug();
    
    Word *sorted[size];
    h.sort(sorted);
    for(int j = 0; j < size; j++){
        cout << " j = " << j << " : " << *sorted[j] << endl;
        delete sorted[j];
    }
    h.printDebug();

    return 0;
}
