// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// address translator (mapping)
// $Id: XMap.cc,v 0.9 1997-12-27 07:27:23+09 harada Exp $
//
#include "SX.h"
#include "XMap.h"

XMap::XMap(int filedesc)
    : fd(filedesc)
{
    struct stat st;
    fstat(fd, &st);
    mapsize = st.st_size;
    entryNum = mapsize / ENTRYSIZE;
/*
    mapaddr = (caddr_t)mmap(NULL,        // start address (hint)
*/
    mapaddr = (XMapEntry*)mmap(NULL,        // start address (hint)
                   mapsize,     // size
                   PROT_READ,   // protection
                   MAP_SHARED,  // flags
                   fd,          // file descriptor
                   (off_t)0 );         // file offset
/*
    if((caddr_t)(-1) == mapaddr)
*/
    if((XMapEntry*)(-1) == mapaddr)
        PRINTERRMSG("mmap() failed.");
}

XMap::~XMap(){
    if(mapaddr && -1 == (int)munmap((caddr_t)mapaddr, mapsize)){
        PRINTERRMSG("munmap(2) failed.");
    }
    if(-1 == close(fd))
        PRINTERRMSG("close(2) failed.");
}
