// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// address translator (mapping)
// $Id: XMap.h,v 0.11 1997-12-29 15:13:43+09 harada Exp $
//
#ifndef XMAP_H_INCLUDED
#define XMAP_H_INCLUDED

#ifdef SUNOS4
extern "C" caddr_t mmap(caddr_t addr, size_t len, int prot,
                    int flags, int fd, off_t off);
extern "C" int munmap(caddr_t addr, int len);
#endif

typedef struct {
/*
    int last; // base of the document -- by cummurative word number in documents
*/
    unsigned int last; // base of the document -- by cummurative word number in documents
/*
    int size; // size of the document -- to be the number of words
*/
} XMapEntry;

class XMap {
private:
    const int fd;
/*
    caddr_t mapaddr;
*/
    XMapEntry *mapaddr;
    size_t mapsize;
    int entryNum;
/*
    int getlast(int n) const {
*/
    unsigned int getlast(int n) const {
        if( mapaddr == (XMapEntry*)-1 )
           return 0;
        return ntohl(mapaddr[n].last);
    }
public:
    enum { ENTRYSIZE = sizeof(XMapEntry) };
    XMap(int filedesc);
    ~XMap();
/*
    operator bool() const { return (caddr_t)(-1) != mapaddr; }
*/
    operator bool() const { return (XMapEntry*)(-1) != mapaddr; }
/*
    int getdocbase(int n) const;
*/
    unsigned int getdocbase(int n) const;
    int getdocsize(int n) const;
    int getdocNum() const { return entryNum; }
};

/*
inline int
*/
inline unsigned int
XMap::getdocbase(int n) const{
/*
    if(n < 0 || entryNum <= n) return -1;
*/
    if(n < 0 || entryNum <= n)
	return (unsigned int)-1;
    if(n == 0)
        return 0;
    else
        return getlast(n-1);
/*
        return ((XMapEntry*)mapaddr)[n-1].last;
*/
}
inline int
XMap::getdocsize(int n) const{
    if(n < 0 || entryNum <= n) return -1;
/*
    return ((XMapEntry*)mapaddr)[n].size;
*/
    if(n == 0)
/*
        return mapaddr[n].last;
*/
        return getlast(n);
    else
        return getlast(n) - getlast(n-1);
/*
        return mapaddr[n].last - mapaddr[n-1].last;
*/
}

#endif

// ե readonly Ȥmmap롣
// .mapեΤ̤Υץ(Ūˤϸ­Ƥ)

// ե륵 (ºݤURL + 1)16byte
// Ǹ16byteֿͤȤߤκΥɥ쥹ؤ̣ġ
