#include <stdio.h>
#include <fcntl.h>

int
main(int ac, char *av[]){
	int ch;
	FILE *in,*out;

#ifdef O_BINARY
	extern int _fmode;
	_fmode = O_BINARY;
#endif
	if( 2 < ac ){
		if( strcmp(av[1],av[2]) == 0 ){
			char old[1024];
			sprintf(old,"%s~",av[1]);
			unlink(old);
			rename(av[1],old);
			av[1] = old;
		}
	}
	if( 1 < ac )
		in = fopen(av[1],"r");
	else	in = stdin;

	if( 2 < ac )
		out = fopen(av[2],"w");
	else	out = stdout;

	if( in == NULL || out == NULL )
		return -1;

	while( (ch = getc(in)) != EOF ){
		if( ch & 0x80 ){
			fprintf(out,"\\%3o",ch);
		}else{
			putc(ch,out);
		}
	}
	return 0;
}
