#!/bin/sh
# new-140708a

echo "#### create b2o.exe"
export TARGET=b2o.exe
./make-vs8_win8.bat
ls -l b2o.exe
unset TARGET
echo "####"

if [ ! -d vc ]; then
	mkdir vc
fi

b2o.exe Coder.h		vc/Coder.h
b2o.exe ConText.cc	vc/ConText.cc
b2o.exe ConText.h	vc/ConText.h
b2o.exe DescFile.cc	vc/DescFile.cc
b2o.exe DescFile.h	vc/DescFile.h
b2o.exe DescRecord.cc	vc/DescRecord.cc
b2o.exe DescRecord.h	vc/DescRecord.h
b2o.exe Evaluator.cc	vc/Evaluator.cc
b2o.exe Evaluator.h	vc/Evaluator.h
b2o.exe Expression.cc	vc/Expression.cc
b2o.exe Expression.h	vc/Expression.h
b2o.exe HashBag.cc	vc/HashBag.cc
b2o.exe HashBag.h	vc/HashBag.h
b2o.exe HashKey.h	vc/HashKey.h
b2o.exe HeapBag.cc	vc/HeapBag.cc
b2o.exe HeapBag.h	vc/HeapBag.h
b2o.exe IndexFile.cc	vc/IndexFile.cc
b2o.exe IndexFile.h	vc/IndexFile.h
b2o.exe Indexer.cc	vc/Indexer.cc
b2o.exe Indexer.h	vc/Indexer.h
b2o.exe Label.cc	vc/Label.cc
b2o.exe Label.h		vc/Label.h
b2o.exe LexiconEntry.cc	 vc/LexiconEntry.cc
b2o.exe LexiconEntry.h	vc/LexiconEntry.h
b2o.exe LexiconFile.cc	vc/LexiconFile.cc
b2o.exe LexiconFile.h	vc/LexiconFile.h
b2o.exe Query.cc	vc/Query.cc
b2o.exe Query.h		vc/Query.h
b2o.exe Result.cc	vc/Result.cc
b2o.exe Result.h	vc/Result.h
b2o.exe Retriever.cc	vc/Retriever.cc
b2o.exe Retriever.h	vc/Retriever.h
b2o.exe SX.cc		vc/SX.cc
b2o.exe SX.h		vc/SX.h
b2o.exe SXc.c		vc/SXc.c
b2o.exe SXc.h		vc/SXc.h
b2o.exe Std.cc		vc/Std.cc
b2o.exe String.cc	vc/String.cc
b2o.exe Unifier.cc	vc/Unifier.cc
b2o.exe Unifier.h	vc/Unifier.h
b2o.exe Word.cc		vc/Word.cc
b2o.exe Word.h		vc/Word.h
b2o.exe WordBreaker.cc	vc/WordBreaker.cc
b2o.exe WordBreaker.h	vc/WordBreaker.h
b2o.exe XMap.cc		vc/XMap.cc
b2o.exe XMap.h		vc/XMap.h
b2o.exe b2o.c		vc/b2o.c
b2o.exe config.h	vc/config.h
b2o.exe findex.cc	vc/findex.cc
b2o.exe fmerge.cc	vc/fmerge.cc
b2o.exe fmkmorphdic.cc	vc/fmkmorphdic.cc
b2o.exe foo.h		vc/foo.h
b2o.exe fsearch.cc	vc/fsearch.cc
b2o.exe fsearchcgi.cc	vc/fsearchcgi.cc
b2o.exe fsx.cc		vc/fsx.cc
b2o.exe htmlutil.cc	vc/htmlutil.cc
b2o.exe htmlutil.h	vc/htmlutil.h
b2o.exe jlib.cc		vc/jlib.cc
b2o.exe jlib.h		vc/jlib.h
b2o.exe kcnvlib.cc	vc/kcnvlib.cc
b2o.exe kcnvlib.h	vc/kcnvlib.h
b2o.exe patricia.cc	vc/patricia.cc
b2o.exe patricia.h	vc/patricia.h
b2o.exe settemplate.cc	vc/settemplate.cc
b2o.exe settemplate.h	vc/settemplate.h
b2o.exe typedef.h	vc/typedef.h
b2o.exe valueSet.h	vc/valueSet.h

cp -p Makefile.VS8 vc/Makefile
cp -p make-vs8_win8.bat vc/make-vs8_win8.bat

echo "####"
cd vc
echo PWD=`pwd`
./make-vs8_win8.bat 

cd ..

echo ""
echo "######## build at ./vc/ ########"
echo "######## installing to ../bin/ ########"

echo ""
pwd
ls -l vc/*.exe
cp -vp vc/fsearch.exe ../bin/
cp -vp vc/findex.exe ../bin/
cp -vp vc/fmerge.exe ../bin/
cp -vp vc/fsxcgi.exe ../cgi-bin/
cp -vp vc/fsearchcgi.exe ../cgi-bin/

exit 0
